diff -pruN 0.3.0-3/CHANGELOG.md 0.4.0-1/CHANGELOG.md
--- 0.3.0-3/CHANGELOG.md	1970-01-01 00:00:00.000000000 +0000
+++ 0.4.0-1/CHANGELOG.md	2020-07-01 22:53:52.000000000 +0000
@@ -0,0 +1,4 @@
+# clitest changelog
+
+The changelog is here:
+https://github.com/aureliojargas/clitest/releases
diff -pruN 0.3.0-3/clitest 0.4.0-1/clitest
--- 0.3.0-3/clitest	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/clitest	2020-07-01 22:53:52.000000000 +0000
@@ -7,9 +7,8 @@
 # GitHub:  https://github.com/aureliojargas/clitest
 #
 # POSIX shell script:
-#   This script was coded to be compatible with POSIX shells.
-#   Tested in Bash 3.2, dash 0.5.5.1, ksh 93u 2011-02-08.
-#   Note: Can't set -o posix nor POSIXLY_CORRECT: test env must be intact.
+#   This script is carefully coded to be compatible with POSIX shells.
+#   It is currently tested in bash, dash, ksh, zsh and busybox's sh.
 #
 # Exit codes:
 #   0  All tests passed, or normal operation (--help, --list, ...)
@@ -19,16 +18,16 @@
 # Test environment:
 #   By default, the tests will run in the current working directory ($PWD).
 #   You can change to another dir normally using 'cd' inside the test file.
-#   All the tests are executed in the same shell, using eval. Test data
-#   such as variables and working directory will persist between tests.
+#   All the tests are executed in the same shell session, using eval. Test
+#   data such as variables and working directory will persist between tests.
 #
 # Namespace:
 #   All variables and functions in this script are prefixed by 'tt_' to
 #   avoid clashing with test's variables, functions, aliases and commands.
 
 tt_my_name="$(basename "$0")"
-tt_my_version='HEAD'
-tt_my_version_url="https://github.com/aureliojargas/clitest/tree/$tt_my_version"
+tt_my_url='https://github.com/aureliojargas/clitest'
+tt_my_version='0.4.0'
 
 # Customization (if needed, edit here or use the command line options)
 tt_prefix=''
@@ -60,7 +59,9 @@ Customization options:
       --diff-options OPTIONS  Set diff command options (default: '$tt_diff_options')
       --inline-prefix PREFIX  Set inline output prefix (default: '$tt_inline_prefix')
       --prefix PREFIX         Set command line prefix (default: '$tt_prefix')
-      --prompt STRING         Set prompt string (default: '$tt_prompt')"
+      --prompt STRING         Set prompt string (default: '$tt_prompt')
+
+See also: $tt_my_url"
 
 # Flags (0=off, 1=on), most can be altered by command line options
 tt_debug=0
@@ -109,40 +110,33 @@ tt_tab='	'
 tt_nl='
 '
 
-
 ### Utilities
 
-tt_clean_up ()
-{
+tt_clean_up() {
     rm -rf "$tt_temp_dir"
 }
-tt_message ()
-{
+tt_message() {
     test "$tt_output_mode" = 'quiet' && return 0
     test $tt_missing_nl -eq 1 && echo
     printf '%s\n' "$*"
     tt_separator_line_shown=0
     tt_missing_nl=0
 }
-tt_message_part ()  # no line break
-{
+tt_message_part() { # no line break
     test "$tt_output_mode" = 'quiet' && return 0
     printf '%s' "$*"
     tt_separator_line_shown=0
     tt_missing_nl=1
 }
-tt_error ()
-{
+tt_error() {
     test $tt_missing_nl -eq 1 && echo
     printf '%s\n' "$tt_my_name: Error: $1" >&2
     tt_clean_up
     exit 2
 }
-tt_debug ()  # $1=id, $2=contents
-{
+tt_debug() { # $1=id, $2=contents
     test $tt_debug -ne 1 && return 0
-    if test INPUT_LINE = "$1"
-    then
+    if test INPUT_LINE = "$1"; then
         # Original input line is all blue
         printf "${tt_color_blue}[%10s: %s]${tt_color_off}\n" "$1" "$2"
     else
@@ -152,40 +146,35 @@ tt_debug ()  # $1=id, $2=contents
             sed "s/$tt_tab/${tt_color_green}<tab>${tt_color_off}/g"
     fi
 }
-tt_separator_line ()
-{
+tt_separator_line() {
     printf "%${COLUMNS}s" ' ' | tr ' ' -
 }
-tt_list_test ()  # $1=normal|list|ok|fail
-{
+tt_list_test() { # $1=normal|list|ok|fail
     # Show the test command in normal mode, --list and --list-run
     case "$1" in
         normal | list)
             # Normal line, no color, no stamp (--list)
             tt_message "#${tt_test_number}${tt_tab}${tt_test_command}"
-        ;;
+            ;;
         ok)
             # Green line or OK stamp (--list-run)
-            if test $tt_use_colors -eq 1
-            then
+            if test $tt_use_colors -eq 1; then
                 tt_message "${tt_color_green}#${tt_test_number}${tt_tab}${tt_test_command}${tt_color_off}"
             else
                 tt_message "#${tt_test_number}${tt_tab}OK${tt_tab}${tt_test_command}"
             fi
-        ;;
+            ;;
         fail)
             # Red line or FAIL stamp (--list-run)
-            if test $tt_use_colors -eq 1
-            then
+            if test $tt_use_colors -eq 1; then
                 tt_message "${tt_color_red}#${tt_test_number}${tt_tab}${tt_test_command}${tt_color_off}"
             else
                 tt_message "#${tt_test_number}${tt_tab}FAIL${tt_tab}${tt_test_command}"
             fi
-        ;;
+            ;;
     esac
 }
-tt_parse_range ()  # $1=range
-{
+tt_parse_range() { # $1=range
     # Parse numeric ranges and output them in an expanded format
     #
     #     Supported formats             Expanded
@@ -199,14 +188,14 @@ tt_parse_range ()  # $1=range
     #     Later we will just grep for :number: in each test.
 
     case "$1" in
-        # No range, nothing to do
         0 | '')
+            # No range, nothing to do
             return 0
-        ;;
-        # Error: strange chars, not 0123456789,-
+            ;;
         *[!0-9,-]*)
+            # Error: strange chars, not 0123456789,-
             return 1
-        ;;
+            ;;
     esac
 
     # OK, all valid chars in range, let's parse them
@@ -214,12 +203,11 @@ tt_parse_range ()  # $1=range
     tt_part=
     tt_n1=
     tt_n2=
-    tt_operation=
+    tt_swap=
     tt_range_data=':'  # :1:2:4:7:
 
     # Loop each component: a number or a range
-    for tt_part in $(echo "$1" | tr , ' ')
-    do
+    for tt_part in $(echo "$1" | tr , ' '); do
         # If there's an hyphen, it's a range
         case "$tt_part" in
             *-*)
@@ -229,29 +217,31 @@ tt_parse_range ()  # $1=range
                 tt_n1=${tt_part%-*}
                 tt_n2=${tt_part#*-}
 
-                tt_operation='+'
-                test $tt_n1 -gt $tt_n2 && tt_operation='-'
+                # Negative range, let's just reverse it (5-1 => 1-5)
+                if test "$tt_n1" -gt "$tt_n2"; then
+                    tt_swap=$tt_n1
+                    tt_n1=$tt_n2
+                    tt_n2=$tt_swap
+                fi
 
                 # Expand the range (1-4 => 1:2:3:4)
                 tt_part=$tt_n1:
-                while test $tt_n1 -ne $tt_n2
-                do
-                    tt_n1=$(($tt_n1 $tt_operation 1))
+                while test "$tt_n1" -ne "$tt_n2"; do
+                    tt_n1=$((tt_n1 + 1))
                     tt_part=$tt_part$tt_n1:
                 done
                 tt_part=${tt_part%:}
-            ;;
+                ;;
         esac
 
         # Append the number or expanded range to the holder
-        test $tt_part != 0 && tt_range_data=$tt_range_data$tt_part:
+        test "$tt_part" != 0 && tt_range_data=$tt_range_data$tt_part:
     done
 
-    test $tt_range_data != ':' && echo $tt_range_data
+    test "$tt_range_data" != ':' && echo "$tt_range_data"
     return 0
 }
-tt_reset_test_data ()
-{
+tt_reset_test_data() {
     tt_test_command=
     tt_test_inline=
     tt_test_mode=
@@ -260,27 +250,24 @@ tt_reset_test_data ()
     tt_test_diff=
     tt_test_ok_text=
 }
-tt_run_test ()
-{
-    tt_test_number=$(($tt_test_number + 1))
-    tt_nr_total_tests=$(($tt_nr_total_tests + 1))
-    tt_nr_file_tests=$(($tt_nr_file_tests + 1))
+tt_run_test() {
+    tt_test_number=$((tt_test_number + 1))
+    tt_nr_total_tests=$((tt_nr_total_tests + 1))
+    tt_nr_file_tests=$((tt_nr_file_tests + 1))
 
     # Run range on: skip this test if it's not listed in $tt_run_range_data
-    if test -n "$tt_run_range_data" && test "$tt_run_range_data" = "${tt_run_range_data#*:$tt_test_number:}"
-    then
-        tt_nr_total_skips=$(($tt_nr_total_skips + 1))
-        tt_nr_file_skips=$(($tt_nr_file_skips + 1))
+    if test -n "$tt_run_range_data" && test "$tt_run_range_data" = "${tt_run_range_data#*:$tt_test_number:}"; then
+        tt_nr_total_skips=$((tt_nr_total_skips + 1))
+        tt_nr_file_skips=$((tt_nr_file_skips + 1))
         tt_reset_test_data
         return 0
     fi
 
     # Skip range on: skip this test if it's listed in $tt_skip_range_data
     # Note: --skip always wins over --test, regardless of order
-    if test -n "$tt_skip_range_data" && test "$tt_skip_range_data" != "${tt_skip_range_data#*:$tt_test_number:}"
-    then
-        tt_nr_total_skips=$(($tt_nr_total_skips + 1))
-        tt_nr_file_skips=$(($tt_nr_file_skips + 1))
+    if test -n "$tt_skip_range_data" && test "$tt_skip_range_data" != "${tt_skip_range_data#*:$tt_test_number:}"; then
+        tt_nr_total_skips=$((tt_nr_total_skips + 1))
+        tt_nr_file_skips=$((tt_nr_file_skips + 1))
         tt_reset_test_data
         return 0
     fi
@@ -291,24 +278,24 @@ tt_run_test ()
             case "$tt_progress" in
                 test)
                     tt_list_test normal
-                ;;
+                    ;;
                 number)
                     tt_message_part "$tt_test_number "
-                ;;
+                    ;;
                 none)
                     :
-                ;;
+                    ;;
                 *)
                     tt_message_part "$tt_progress"
-                ;;
+                    ;;
             esac
-        ;;
+            ;;
         list)
             # List mode: just show the command and return (no execution)
             tt_list_test list
             tt_reset_test_data
             return 0
-        ;;
+            ;;
     esac
 
     #tt_debug EVAL "$tt_test_command"
@@ -325,59 +312,54 @@ tt_run_test ()
             printf %s "$tt_test_ok_text" > "$tt_test_ok_file"
             tt_test_diff=$(diff $tt_diff_options "$tt_test_ok_file" "$tt_test_output_file")
             tt_test_status=$?
-        ;;
+            ;;
         text)
             # Inline OK text represents a full line, with \n
             printf '%s\n' "$tt_test_inline" > "$tt_test_ok_file"
             tt_test_diff=$(diff $tt_diff_options "$tt_test_ok_file" "$tt_test_output_file")
             tt_test_status=$?
-        ;;
+            ;;
         eval)
             eval "$tt_test_inline" > "$tt_test_ok_file"
             tt_test_diff=$(diff $tt_diff_options "$tt_test_ok_file" "$tt_test_output_file")
             tt_test_status=$?
-        ;;
+            ;;
         lines)
             tt_test_output=$(sed -n '$=' "$tt_test_output_file")
             test -z "$tt_test_output" && tt_test_output=0
             test "$tt_test_output" -eq "$tt_test_inline"
             tt_test_status=$?
             tt_test_diff="Expected $tt_test_inline lines, got $tt_test_output."
-        ;;
+            ;;
         file)
             # If path is relative, make it relative to the test file path, not $PWD
-            if test $tt_test_inline = ${tt_test_inline#/}
-            then
+            if test "$tt_test_inline" = "${tt_test_inline#/}"; then
                 tt_test_inline="$(dirname "$tt_test_file")/$tt_test_inline"
             fi
             # Abort when ok file not found/readable
-            if test ! -f "$tt_test_inline" || test ! -r "$tt_test_inline"
-            then
+            if test ! -f "$tt_test_inline" || test ! -r "$tt_test_inline"; then
                 tt_error "cannot read inline output file '$tt_test_inline', from line $tt_line_number of $tt_test_file"
             fi
 
             tt_test_diff=$(diff $tt_diff_options "$tt_test_inline" "$tt_test_output_file")
             tt_test_status=$?
-        ;;
+            ;;
         egrep)
-            egrep "$tt_test_inline" "$tt_test_output_file" > /dev/null
+            grep -E "$tt_test_inline" "$tt_test_output_file" > /dev/null
             tt_test_status=$?
 
             # Test failed: the regex not matched
-            if test $tt_test_status -eq 1
-            then
+            if test $tt_test_status -eq 1; then
                 tt_test_diff="egrep '$tt_test_inline' failed in:$tt_nl$(cat "$tt_test_output_file")"
 
             # Regex errors are common and user must take action to fix them
-            elif test $tt_test_status -gt 1
-            then
+            elif test $tt_test_status -gt 1; then
                 tt_error "check your inline egrep regex at line $tt_line_number of $tt_test_file"
             fi
-        ;;
+            ;;
         perl | regex)
             # Escape regex delimiter (if any) inside the regex: ' => \'
-            if test "$tt_test_inline" != "${tt_test_inline#*\'}"
-            then
+            if test "$tt_test_inline" != "${tt_test_inline#*\'}"; then
                 tt_test_inline=$(printf %s "$tt_test_inline" | sed "s/'/\\\\'/g")
             fi
 
@@ -388,47 +370,44 @@ tt_run_test ()
             case $tt_test_status in
                 0)   # Test matched, nothing to do
                     :
-                ;;
+                    ;;
                 1)   # Test failed: the regex not matched
                     tt_test_diff="Perl regex '$tt_test_inline' not matched in:$tt_nl$(cat "$tt_test_output_file")"
-                ;;
+                    ;;
                 127) # Perl not found :(
                     tt_error "Perl not found. It's needed by --$tt_test_mode at line $tt_line_number of $tt_test_file"
-                ;;
+                    ;;
                 255) # Regex syntax errors are common and user must take action to fix them
                     tt_error "check your inline Perl regex at line $tt_line_number of $tt_test_file"
-                ;;
+                    ;;
                 *)
                     tt_error "unknown error when running Perl for --$tt_test_mode at line $tt_line_number of $tt_test_file"
-                ;;
+                    ;;
             esac
-        ;;
+            ;;
         exit)
             test "$tt_test_exit_code" -eq "$tt_test_inline"
             tt_test_status=$?
             tt_test_diff="Expected exit code $tt_test_inline, got $tt_test_exit_code"
-        ;;
+            ;;
         *)
             tt_error "unknown test mode '$tt_test_mode'"
-        ;;
+            ;;
     esac
 
     # Test failed :(
-    if test $tt_test_status -ne 0
-    then
-        tt_nr_file_fails=$(($tt_nr_file_fails + 1))
-        tt_nr_total_fails=$(($tt_nr_total_fails + 1))
+    if test $tt_test_status -ne 0; then
+        tt_nr_file_fails=$((tt_nr_file_fails + 1))
+        tt_nr_total_fails=$((tt_nr_total_fails + 1))
         tt_failed_range="$tt_failed_range$tt_test_number,"
 
         # Decide the message format
-        if test "$tt_output_mode" = 'list-run'
-        then
+        if test "$tt_output_mode" = 'list-run'; then
             # List mode
             tt_list_test fail
         else
             # Normal mode: show FAILED message and the diff
-            if test $tt_separator_line_shown -eq 0  # avoid dups
-            then
+            if test $tt_separator_line_shown -eq 0; then # avoid dups
                 tt_message "${tt_color_red}$(tt_separator_line)${tt_color_off}"
             fi
             tt_message "${tt_color_red}[FAILED #$tt_test_number, line $tt_test_line_number] $tt_test_command${tt_color_off}"
@@ -438,8 +417,7 @@ tt_run_test ()
         fi
 
         # Should I abort now?
-        if test $tt_stop_on_first_fail -eq 1
-        then
+        if test $tt_stop_on_first_fail -eq 1; then
             tt_clean_up
             exit 1
         fi
@@ -451,8 +429,7 @@ tt_run_test ()
 
     tt_reset_test_data
 }
-tt_process_test_file ()
-{
+tt_process_test_file() {
     # Reset counters
     tt_nr_file_tests=0
     tt_nr_file_fails=0
@@ -463,23 +440,24 @@ tt_process_test_file ()
     # Loop for each line of input file
     # Note: changing IFS to avoid right-trimming of spaces/tabs
     # Note: read -r to preserve the backslashes
-    while IFS='' read -r tt_input_line || test -n "$tt_input_line"
-    do
-        tt_line_number=$(($tt_line_number + 1))
+    while IFS='' read -r tt_input_line || test -n "$tt_input_line"; do
+        tt_line_number=$((tt_line_number + 1))
         #tt_debug INPUT_LINE "$tt_input_line"
 
         case "$tt_input_line" in
 
-            # Prompt alone: closes previous command line (if any)
             "$tt_prefix$tt_prompt" | "$tt_prefix${tt_prompt% }" | "$tt_prefix$tt_prompt ")
+                # Prompt alone: closes previous command line (if any)
+
                 #tt_debug 'LINE_$' "$tt_input_line"
 
                 # Run pending tests
                 test -n "$tt_test_command" && tt_run_test
-            ;;
+                ;;
 
-            # This line is a command line to be tested
             "$tt_prefix$tt_prompt"*)
+                # This line is a command line to be tested
+
                 #tt_debug LINE_CMD "$tt_input_line"
 
                 # Run pending tests
@@ -492,8 +470,7 @@ tt_process_test_file ()
                 tt_test_line_number=$tt_line_number
 
                 # This is a special test with inline output?
-                if printf '%s\n' "$tt_test_command" | grep "$tt_inline_prefix" > /dev/null
-                then
+                if printf '%s\n' "$tt_test_command" | grep "$tt_inline_prefix" > /dev/null; then
                     # Separate command from inline output
                     tt_test_command="${tt_test_command%"$tt_inline_prefix"*}"
                     tt_test_inline="${tt_input_line##*"$tt_inline_prefix"}"
@@ -506,55 +483,53 @@ tt_process_test_file ()
                         '--egrep '*)
                             tt_test_inline=${tt_test_inline#--egrep }
                             tt_test_mode='egrep'
-                        ;;
+                            ;;
                         '--regex '*)  # alias to --perl
                             tt_test_inline=${tt_test_inline#--regex }
                             tt_test_mode='regex'
-                        ;;
+                            ;;
                         '--perl '*)
                             tt_test_inline=${tt_test_inline#--perl }
                             tt_test_mode='perl'
-                        ;;
+                            ;;
                         '--file '*)
                             tt_test_inline=${tt_test_inline#--file }
                             tt_test_mode='file'
-                        ;;
+                            ;;
                         '--lines '*)
                             tt_test_inline=${tt_test_inline#--lines }
                             tt_test_mode='lines'
-                        ;;
+                            ;;
                         '--exit '*)
                             tt_test_inline=${tt_test_inline#--exit }
                             tt_test_mode='exit'
-                        ;;
+                            ;;
                         '--eval '*)
                             tt_test_inline=${tt_test_inline#--eval }
                             tt_test_mode='eval'
-                        ;;
+                            ;;
                         '--text '*)
                             tt_test_inline=${tt_test_inline#--text }
                             tt_test_mode='text'
-                        ;;
+                            ;;
                         *)
                             tt_test_mode='text'
-                        ;;
+                            ;;
                     esac
 
                     #tt_debug OK_TEXT "$tt_test_inline"
 
                     # There must be a number in --lines and --exit
-                    if test "$tt_test_mode" = 'lines' || test "$tt_test_mode" = 'exit'
-                    then
+                    if test "$tt_test_mode" = 'lines' || test "$tt_test_mode" = 'exit'; then
                         case "$tt_test_inline" in
                             '' | *[!0-9]*)
                                 tt_error "--$tt_test_mode requires a number. See line $tt_line_number of $tt_test_file"
-                            ;;
+                                ;;
                         esac
                     fi
 
                     # An empty inline parameter is an error user must see
-                    if test -z "$tt_test_inline" && test "$tt_test_mode" != 'text'
-                    then
+                    if test -z "$tt_test_inline" && test "$tt_test_mode" != 'text'; then
                         tt_error "empty --$tt_test_mode at line $tt_line_number of $tt_test_file"
                     fi
 
@@ -566,18 +541,18 @@ tt_process_test_file ()
 
                     #tt_debug NEW_CMD "$tt_test_command"
                 fi
-            ;;
+                ;;
 
-            # Test output, blank line or comment
             *)
+                # Test output, blank line or comment
+
                 #tt_debug 'LINE_*' "$tt_input_line"
 
                 # Ignore this line if there's no pending test
                 test -n "$tt_test_command" || continue
 
                 # Required prefix is missing: we just left a command block
-                if test -n "$tt_prefix" && test "${tt_input_line#"$tt_prefix"}" = "$tt_input_line"
-                then
+                if test -n "$tt_prefix" && test "${tt_input_line#"$tt_prefix"}" = "$tt_input_line"; then
                     #tt_debug BLOCK_OUT "$tt_input_line"
 
                     # Run the pending test and we're done in this line
@@ -589,7 +564,7 @@ tt_process_test_file ()
                 tt_test_ok_text="$tt_test_ok_text${tt_input_line#"$tt_prefix"}$tt_nl"
 
                 #tt_debug OK_TEXT "${tt_input_line#"$tt_prefix"}"
-            ;;
+                ;;
         esac
     done < "$tt_temp_file"
 
@@ -598,8 +573,7 @@ tt_process_test_file ()
     # Run pending tests
     test -n "$tt_test_command" && tt_run_test
 }
-tt_make_temp_dir ()
-{
+tt_make_temp_dir() {
     # Create private temporary dir and sets global $tt_temp_dir.
     # http://mywiki.wooledge.org/BashFAQ/062
 
@@ -607,59 +581,116 @@ tt_make_temp_dir ()
     tt_temp_dir=$(mktemp -d "${TMPDIR:-/tmp}/clitest.XXXXXX" 2> /dev/null) && return 0
 
     # No mktemp, let's create the dir manually
+    # shellcheck disable=SC2015
     tt_temp_dir="${TMPDIR:-/tmp}/clitest.$(awk 'BEGIN { srand(); print rand() }').$$" &&
-        mkdir -m 700 "$tt_temp_dir" || tt_error "cannot create temporary dir: $tt_temp_dir"
+        mkdir -m 700 "$tt_temp_dir" ||
+        tt_error "cannot create temporary dir: $tt_temp_dir"
 }
 
-
 ### Init process
 
 # Temporary files (using files because <(...) is not portable)
 tt_temp_dir=
 tt_make_temp_dir  # sets global $tt_temp_dir
 tt_temp_file="$tt_temp_dir/temp.txt"
+tt_stdin_file="$tt_temp_dir/stdin.txt"
 tt_test_ok_file="$tt_temp_dir/ok.txt"
 tt_test_output_file="$tt_temp_dir/output.txt"
 
 # Handle command line options
-while test "${1#-}" != "$1"
-do
+while test "${1#-}" != "$1"; do
     case "$1" in
-        -1|--first      ) shift; tt_stop_on_first_fail=1 ;;
-        -l|--list       ) shift; tt_output_mode='list' ;;
-        -L|--list-run   ) shift; tt_output_mode='list-run' ;;
-        -q|--quiet      ) shift; tt_output_mode='quiet' ;;
-        -t|--test       ) shift; tt_run_range="$1"; shift ;;
-        -s|--skip       ) shift; tt_skip_range="$1"; shift ;;
-        --pre-flight    ) shift; tt_pre_command="$1"; shift ;;
-        --post-flight   ) shift; tt_post_command="$1"; shift ;;
-        --debug         ) shift; tt_debug=1 ;;
-        -P|--progress   ) shift; tt_progress="$1"; tt_output_mode='normal'; shift ;;
-        --color|--colour) shift; tt_color_mode="$1"; shift ;;
-        --diff-options  ) shift; tt_diff_options="$1"; shift ;;
-        --inline-prefix ) shift; tt_inline_prefix="$1"; shift ;;
-        --prefix        ) shift; tt_prefix="$1"; shift ;;
-        --prompt        ) shift; tt_prompt="$1"; shift ;;
-        -h|--help)
+        -1 | --first)
+            shift
+            tt_stop_on_first_fail=1
+            ;;
+        -l | --list)
+            shift
+            tt_output_mode='list'
+            ;;
+        -L | --list-run)
+            shift
+            tt_output_mode='list-run'
+            ;;
+        -q | --quiet)
+            shift
+            tt_output_mode='quiet'
+            ;;
+        -t | --test)
+            shift
+            tt_run_range="$1"
+            shift
+            ;;
+        -s | --skip)
+            shift
+            tt_skip_range="$1"
+            shift
+            ;;
+        --pre-flight)
+            shift
+            tt_pre_command="$1"
+            shift
+            ;;
+        --post-flight)
+            shift
+            tt_post_command="$1"
+            shift
+            ;;
+        --debug)
+            shift
+            tt_debug=1
+            ;;
+        -P | --progress)
+            shift
+            tt_progress="$1"
+            tt_output_mode='normal'
+            shift
+            ;;
+        --color | --colour)
+            shift
+            tt_color_mode="$1"
+            shift
+            ;;
+        --diff-options)
+            shift
+            tt_diff_options="$1"
+            shift
+            ;;
+        --inline-prefix)
+            shift
+            tt_inline_prefix="$1"
+            shift
+            ;;
+        --prefix)
+            shift
+            tt_prefix="$1"
+            shift
+            ;;
+        --prompt)
+            shift
+            tt_prompt="$1"
+            shift
+            ;;
+        -h | --help)
             printf '%s\n' "$tt_my_help"
             exit 0
-        ;;
-        -V|--version)
-            printf '%s %s\n%s\n' $tt_my_name $tt_my_version $tt_my_version_url
+            ;;
+        -V | --version)
+            printf '%s %s\n' "$tt_my_name" "$tt_my_version"
             exit 0
-        ;;
+            ;;
         --)
             # No more options to process
             shift
             break
-        ;;
+            ;;
         -)
-            # Argument - means "read from STDIN" (not supported)
+            # Argument - means "read test file from STDIN"
             break
-        ;;
+            ;;
         *)
             tt_error "invalid option $1"
-        ;;
+            ;;
     esac
 done
 
@@ -667,8 +698,7 @@ done
 tt_nr_files=$#
 
 # No files?
-if test $tt_nr_files -eq 0
-then
+if test $tt_nr_files -eq 0; then
     tt_error 'no test file informed (try --help)'
 fi
 
@@ -676,41 +706,40 @@ fi
 case "$tt_prefix" in
     tab)
         tt_prefix="$tt_tab"
-    ;;
+        ;;
     0)
         tt_prefix=''
-    ;;
+        ;;
     [1-9] | [1-9][0-9])  # 1-99
         # convert number to spaces: 2 => '  '
         tt_prefix=$(printf "%${tt_prefix}s" ' ')
-    ;;
+        ;;
     *\\*)
         tt_prefix="$(printf %b "$tt_prefix")"  # expand \t and others
-    ;;
+        ;;
 esac
 
 # Validate and normalize progress value
-if test "$tt_output_mode" = 'normal'
-then
+if test "$tt_output_mode" = 'normal'; then
     case "$tt_progress" in
         test)
             :
-        ;;
+            ;;
         number | n | [0-9])
             tt_progress='number'
-        ;;
+            ;;
         dot | .)
             tt_progress='.'
-        ;;
+            ;;
         none | no)
             tt_progress='none'
-        ;;
+            ;;
         ?)  # Single char, use it as the progress
             :
-        ;;
+            ;;
         *)
             tt_error "invalid value '$tt_progress' for --progress. Use: test, number, dot or none."
-        ;;
+            ;;
     esac
 fi
 
@@ -718,30 +747,28 @@ fi
 case "$tt_color_mode" in
     always | yes | y)
         tt_use_colors=1
-    ;;
+        ;;
     never | no | n)
         tt_use_colors=0
-    ;;
+        ;;
     auto | a)
         # The auto mode will use colors if the output is a terminal
         # Note: test -t is in POSIX
-        if test -t 1
-        then
+        if test -t 1; then
             tt_use_colors=1
         else
             tt_use_colors=0
         fi
-    ;;
+        ;;
     *)
         tt_error "invalid value '$tt_color_mode' for --color. Use: auto, always or never."
-    ;;
+        ;;
 esac
 
 # Set colors
 # Remember: colors must be readable in dark and light backgrounds
 # Customization: tweak the numbers after [ to adjust the colors
-if test $tt_use_colors -eq 1
-then
+if test $tt_use_colors -eq 1; then
     tt_color_red=$(  printf '\033[31m')  # fail
     tt_color_green=$(printf '\033[32m')  # ok
     tt_color_blue=$( printf '\033[34m')  # debug
@@ -754,65 +781,70 @@ fi
 # In other shells, try to use 'tput cols' (not POSIX).
 # If not, defaults to 50 columns, a conservative amount.
 : ${COLUMNS:=$(tput cols 2> /dev/null)}
-: ${COLUMNS:=50}
+: "${COLUMNS:=50}"
 
 # Parse and validate --test option value, if informed
 tt_run_range_data=$(tt_parse_range "$tt_run_range")
-if test $? -ne 0
-then
+if test $? -ne 0; then
     tt_error "invalid argument for -t or --test: $tt_run_range"
 fi
 
 # Parse and validate --skip option value, if informed
 tt_skip_range_data=$(tt_parse_range "$tt_skip_range")
-if test $? -ne 0
-then
+if test $? -ne 0; then
     tt_error "invalid argument for -s or --skip: $tt_skip_range"
 fi
 
-
 ### Real execution begins here
 
 # Some preparing command to run before all the tests?
-if test -n "$tt_pre_command"
-then
+if test -n "$tt_pre_command"; then
     eval "$tt_pre_command" ||
         tt_error "pre-flight command failed with status=$?: $tt_pre_command"
 fi
 
 # For each input file in $@
-for tt_test_file
-do
+for tt_test_file; do
     # Some tests may 'cd' to another dir, we need to get back
     # to preserve the relative paths of the input files
-    cd "$tt_original_dir"
+    cd "$tt_original_dir" ||
+        tt_error "cannot enter starting directory $tt_original_dir"
+
+    # Support using '-' to read the test file from STDIN
+    if test "$tt_test_file" = '-'; then
+        tt_test_file="$tt_stdin_file"
+        cat > "$tt_test_file"
+    fi
+
+    # Abort when test file is a directory
+    if test -d "$tt_test_file"; then
+        tt_error "input file is a directory: $tt_test_file"
+    fi
 
     # Abort when test file not found/readable
-    if test ! -f "$tt_test_file" || test ! -r "$tt_test_file"
-    then
+    if test ! -r "$tt_test_file"; then
         tt_error "cannot read input file: $tt_test_file"
     fi
 
     # In multifile mode, identify the current file
-    if test $tt_nr_files -gt 1
-    then
+    if test $tt_nr_files -gt 1; then
         case "$tt_output_mode" in
             normal)
                 # Normal mode, show message with filename
                 case "$tt_progress" in
                     test | none)
                         tt_message "Testing file $tt_test_file"
-                    ;;
+                        ;;
                     *)
                         test $tt_missing_nl -eq 1 && echo
                         tt_message_part "Testing file $tt_test_file "
-                    ;;
+                        ;;
                 esac
-            ;;
+                ;;
             list | list-run)
                 # List mode, show ------ and the filename
                 tt_message "$(tt_separator_line | cut -c 1-40)" "$tt_test_file"
-            ;;
+                ;;
         esac
     fi
 
@@ -825,13 +857,12 @@ do
     tt_process_test_file
 
     # Abort when no test found (and no active range with --test or --skip)
-    if test $tt_nr_file_tests -eq 0 && test -z "$tt_run_range_data" && test -z "$tt_skip_range_data"
-    then
+    if test $tt_nr_file_tests -eq 0 && test -z "$tt_run_range_data" && test -z "$tt_skip_range_data"; then
         tt_error "no test found in input file: $tt_test_file"
     fi
 
     # Save file stats
-    tt_nr_file_ok=$(($tt_nr_file_tests - $tt_nr_file_fails - $tt_nr_file_skips))
+    tt_nr_file_ok=$((tt_nr_file_tests - tt_nr_file_fails - tt_nr_file_skips))
     tt_files_stats="$tt_files_stats$tt_nr_file_ok $tt_nr_file_fails $tt_nr_file_skips$tt_nl"
 
     # Dots mode: any missing new line?
@@ -842,9 +873,9 @@ done
 tt_clean_up
 
 # Some clean up command to run after all the tests?
-if test -n "$tt_post_command"
-then
-    eval "$tt_post_command"
+if test -n "$tt_post_command"; then
+    eval "$tt_post_command" ||
+        tt_error "post-flight command failed with status=$?: $tt_post_command"
 fi
 
 #-----------------------------------------------------------------------
@@ -852,25 +883,19 @@ fi
 #-----------------------------------------------------------------------
 
 # Range active, but no test matched :(
-if test $tt_nr_total_tests -eq $tt_nr_total_skips
-then
-    if test -n "$tt_run_range_data" && test -n "$tt_skip_range_data"
-    then
+if test $tt_nr_total_tests -eq $tt_nr_total_skips; then
+    if test -n "$tt_run_range_data" && test -n "$tt_skip_range_data"; then
         tt_error "no test found. The combination of -t and -s resulted in no tests."
-    elif test -n "$tt_run_range_data"
-    then
+    elif test -n "$tt_run_range_data"; then
         tt_error "no test found for the specified number or range '$tt_run_range'"
-    elif test -n "$tt_skip_range_data"
-    then
+    elif test -n "$tt_skip_range_data"; then
         tt_error "no test found. Maybe '--skip $tt_skip_range' was too much?"
     fi
 fi
 
 # List mode has no stats
-if test "$tt_output_mode" = 'list' || test "$tt_output_mode" = 'list-run'
-then
-    if test $tt_nr_total_fails -eq 0
-    then
+if test "$tt_output_mode" = 'list' || test "$tt_output_mode" = 'list-run'; then
+    if test $tt_nr_total_fails -eq 0; then
         exit 0
     else
         exit 1
@@ -885,13 +910,11 @@ fi
 #          ok  fail  skip
 #         100     0    23  foo.sh
 #          12    34     0  bar.sh
-if test $tt_nr_files -gt 1 && test "$tt_output_mode" != 'quiet'
-then
+if test $tt_nr_files -gt 1 && test "$tt_output_mode" != 'quiet'; then
     echo
     printf '  %5s %5s %5s\n' ok fail skip
-    printf %s "$tt_files_stats" | while read ok fail skip
-    do
-        printf '  %5s %5s %5s    %s\n' $ok $fail $skip "$1"
+    printf %s "$tt_files_stats" | while read -r ok fail skip; do
+        printf '  %5s %5s %5s    %s\n' "$ok" "$fail" "$skip" "$1"
         shift
     done | sed 's/     0/     -/g'  # hide zeros
     echo
@@ -903,14 +926,12 @@ fi
 #   FAIL: 123 of 123 tests failed
 #   FAIL: 100 of 123 tests failed (23 skipped)
 skips=
-if test $tt_nr_total_skips -gt 0
-then
+if test $tt_nr_total_skips -gt 0; then
     skips=" ($tt_nr_total_skips skipped)"
 fi
-if test $tt_nr_total_fails -eq 0
-then
+if test $tt_nr_total_fails -eq 0; then
     stamp="${tt_color_green}OK:${tt_color_off}"
-    stats="$(($tt_nr_total_tests - $tt_nr_total_skips)) of $tt_nr_total_tests tests passed"
+    stats="$((tt_nr_total_tests - tt_nr_total_skips)) of $tt_nr_total_tests tests passed"
     test $tt_nr_total_tests -eq 1 && stats=$(echo "$stats" | sed 's/tests /test /')
     tt_message "$stamp $stats$skips"
     exit 0
diff -pruN 0.3.0-3/debian/changelog 0.4.0-1/debian/changelog
--- 0.3.0-3/debian/changelog	2020-06-14 13:40:40.000000000 +0000
+++ 0.4.0-1/debian/changelog	2021-02-06 14:48:20.000000000 +0000
@@ -1,3 +1,10 @@
+clitest (0.4.0-1) unstable; urgency=medium
+
+  * New upstream version 0.4.0
+  * Bump Standards-Version to 4.5.1; no changes needed
+
+ -- Antonio Terceiro <terceiro@debian.org>  Sat, 06 Feb 2021 11:48:20 -0300
+
 clitest (0.3.0-3) unstable; urgency=medium
 
   * Bump debhelper from old 10 to 12.
diff -pruN 0.3.0-3/debian/control 0.4.0-1/debian/control
--- 0.3.0-3/debian/control	2020-06-14 13:40:40.000000000 +0000
+++ 0.4.0-1/debian/control	2021-02-06 14:48:20.000000000 +0000
@@ -3,7 +3,7 @@ Section: misc
 Priority: optional
 Maintainer: Antonio Terceiro <terceiro@debian.org>
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/aureliojargas/clitest
 Vcs-Browser: https://salsa.debian.org/debian/clitest
 Vcs-Git: https://salsa.debian.org/debian/clitest.git
diff -pruN 0.3.0-3/Dockerfile.dev 0.4.0-1/Dockerfile.dev
--- 0.3.0-3/Dockerfile.dev	1970-01-01 00:00:00.000000000 +0000
+++ 0.4.0-1/Dockerfile.dev	2020-07-01 22:53:52.000000000 +0000
@@ -0,0 +1,19 @@
+# clitest-dev
+# Local Docker image used for clitest development.
+#
+# It has all the required tools for linting and testing clitest code.
+# See Makefile for commands to build and run this image.
+#
+# If you're searching for the official clitest Docker image (for users):
+# https://hub.docker.com/r/aureliojargas/clitest
+
+FROM alpine:3.12
+
+# Perl is required by clitest's --regex matching mode
+RUN apk --no-cache add \
+    bash dash mksh zsh \
+    perl \
+    make \
+    checkbashisms shellcheck shfmt
+
+WORKDIR /mnt
diff -pruN 0.3.0-3/.dockerignore 0.4.0-1/.dockerignore
--- 0.3.0-3/.dockerignore	1970-01-01 00:00:00.000000000 +0000
+++ 0.4.0-1/.dockerignore	2020-07-01 22:53:52.000000000 +0000
@@ -0,0 +1 @@
+.git
diff -pruN 0.3.0-3/.editorconfig 0.4.0-1/.editorconfig
--- 0.3.0-3/.editorconfig	1970-01-01 00:00:00.000000000 +0000
+++ 0.4.0-1/.editorconfig	2020-07-01 22:53:52.000000000 +0000
@@ -0,0 +1,15 @@
+root = true
+
+[*]
+indent_style = space
+indent_size = 4
+end_of_line = lf
+charset = utf-8
+trim_trailing_whitespace = true
+insert_final_newline = true
+
+[*.md]
+trim_trailing_whitespace = false
+
+[*.yml]
+indent_size = 2
diff -pruN 0.3.0-3/examples/install-software.md 0.4.0-1/examples/install-software.md
--- 0.3.0-3/examples/install-software.md	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/examples/install-software.md	2020-07-01 22:53:52.000000000 +0000
@@ -17,7 +17,7 @@ and test the txt2tags package before ins
 
 Download the .tgz file for the version 2.6, directly from Google Code.
 
-	$ url="http://txt2tags.googlecode.com/files/txt2tags-2.6.tgz"
+	$ url="https://fossies.org/linux/privat/txt2tags-2.6.tgz"
 	$ curl -O -s -S "$url"
 
 
diff -pruN 0.3.0-3/examples/install-software.txt 0.4.0-1/examples/install-software.txt
--- 0.3.0-3/examples/install-software.txt	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/examples/install-software.txt	2020-07-01 22:53:52.000000000 +0000
@@ -1,5 +1,5 @@
 $ cd /tmp
-$ url="http://txt2tags.googlecode.com/files/txt2tags-2.6.tgz"
+$ url="https://fossies.org/linux/privat/txt2tags-2.6.tgz"
 $ curl -O -s -S "$url"                     # download
 $ du -h txt2tags-2.6.tgz                   # verify size
 532K	txt2tags-2.6.tgz
diff -pruN 0.3.0-3/.gitignore 0.4.0-1/.gitignore
--- 0.3.0-3/.gitignore	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/.gitignore	2020-07-01 22:53:52.000000000 +0000
@@ -1 +1 @@
-/local/
+.vscode
diff -pruN 0.3.0-3/Makefile 0.4.0-1/Makefile
--- 0.3.0-3/Makefile	1970-01-01 00:00:00.000000000 +0000
+++ 0.4.0-1/Makefile	2020-07-01 22:53:52.000000000 +0000
@@ -0,0 +1,37 @@
+# Developer workflow: run locally the same commands Travis will run in
+# the CI. See the .travis.yml file for the list of commands.
+#
+# By default, the linting and testing targets are run inside the
+# clitest-dev Docker container. To run them directly on the host,
+# avoiding the container, unset the `docker_run` variable. Examples:
+#
+#    make test-bash                # test using container's bash
+#    make test-bash docker_run=    # test using host's bash
+
+docker_image = clitest-dev
+docker_run = docker run --rm -it -v $$PWD:/mnt $(docker_image)
+test_cmd = ./clitest --first --progress none test.md
+
+default:
+	@echo "Read the comments in the Makefile for help"
+
+fmt:
+	$(docker_run) shfmt -w -i 4 -ci -kp -sr clitest
+
+lint:
+	$(docker_run) shfmt -d -i 4 -ci -kp -sr clitest
+	$(docker_run) checkbashisms --posix clitest
+	$(docker_run) shellcheck clitest
+
+test: test-bash test-dash test-mksh test-sh test-zsh
+test-%:
+	$(docker_run) $* $(test_cmd)
+
+versions:
+	@$(docker_run) sh -c 'apk list 2>/dev/null | cut -d " " -f 1 | sort'
+
+docker-build:
+	docker build -t $(docker_image) -f Dockerfile.dev .
+
+docker-run:
+	$(docker_run) $(cmd)
diff -pruN 0.3.0-3/README.md 0.4.0-1/README.md
--- 0.3.0-3/README.md	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/README.md	2020-07-01 22:53:52.000000000 +0000
@@ -33,13 +33,20 @@ sudo mv clitest /usr/bin
 
 Now check if everything is fine:
 
-```console
-$ clitest -V
-clitest HEAD
-https://github.com/aureliojargas/clitest/tree/HEAD
-$
+```
+clitest --help
+```
+
+
+## Docker image
+
+You can also run clitest in a Docker container ([more info in Docker Hub](https://hub.docker.com/r/aureliojargas/clitest)).
+
+```
+docker run --rm -t aureliojargas/clitest --help
 ```
 
+
 ## Quick Intro
 
 Save the commands and their expected output in a text file:
@@ -111,7 +118,9 @@ OK: 6 of 6 tests passed
 $
 ```
 
-There are more examples and instructions in the [examples folder][10]. For a real-life collection of hundreds of test files, see [funcoeszz test files][24].
+There are more examples and instructions in the [examples folder][10].
+For a real-life collection of hundreds of test files, see
+[funcoeszz test files][24].
 
 
 ## Testable Documentation
@@ -189,10 +198,13 @@ no prefix option is needed.
 
 Examples of testable documentation handled by clitest:
 
+* https://github.com/aureliojargas/txt2regex/blob/master/tests/features.md
+* https://github.com/aureliojargas/txt2regex/blob/master/tests/cmdline.md
+* https://github.com/aureliojargas/sedsed/blob/master/test/command_line.md
+* https://github.com/aureliojargas/replace/blob/master/README.md
+* https://github.com/aureliojargas/clitest/blob/master/test.md
 * https://github.com/caarlos0/jvm/blob/master/tests/test.clitest.md
 * https://github.com/caarlos0/git-add-remote/blob/master/tests/suite.clitest.md
-* https://github.com/aureliojargas/clitest/blob/master/examples/install-software.md
-* https://github.com/aureliojargas/clitest/blob/master/test.md
 
 
 ## Alternative Syntax: Inline Output
@@ -317,8 +329,9 @@ previous.
 
 ## Quiet operation
 
-When automating the tests execution, use `--quiet` to show no output
-and just check the exit code to make sure all tests have passed. Using `--first` to fail fast is also a good idea in this case.
+When automating the tests execution, use `--quiet` to show no output and
+just check the exit code to make sure all tests have passed. Using
+`--first` to fail fast is also a good idea in this case.
 
 ```bash
 if clitest --quiet --first tests.txt
@@ -380,16 +393,18 @@ clitest  --prefix 4 --prompt '[john@loca
 ## Nerdiness
 
 * Use any text file format for the tests, it doesn't matter. The command
-  lines just need to be grepable and have a fixed prefix (or none).
+  lines just need to be grepable and have a fixed prefix (or even none).
   Even Windows text files (CR+LF) will work fine.
 
-* The cmdline power is available in your test files: use variables,
+* The command line power is available in your test files: use variables,
   pipes, redirection, create files, folders, move around…
 
-* All the commands are tested in the same shell. Defined variables,
-  aliases and functions will persist between tests.
+* All the commands are tested using a single shell session. This means
+  that variables, aliases and functions defined in one test will persist
+  in the following tests.
 
-* Both STDIN and STDOUT are catch, you can also test error messages.
+* Both STDOUT and STDERR are captured, so you can also test error
+  messages.
 
 * To test STDOUT/STDERR and the exit code at the same time, add a
   `;echo $?` after the command.
@@ -421,9 +436,13 @@ clitest  --prefix 4 --prompt '[john@loca
 
 ## Choose the execution shell
 
-The clitest shebang is `#!/bin/sh`. That's the default shell that will be used to run your test command lines. Depending on the system, that path points to a different shell, such as ash, dash, or bash ([running in POSIX mode][23]).
+The clitest shebang is `#!/bin/sh`. That's the default shell that will
+be used to run your test command lines. Depending on the system, that
+path points to a different shell, such as ash, dash, or bash
+([running in POSIX mode][23]).
 
-To force your test commands to always run on a specific shell, just call the desired shell before:
+To force your test commands to always run on a specific shell, just call
+the desired shell before:
 
 ```bash
 clitest tests.txt            # Uses /bin/sh
@@ -434,14 +453,17 @@ ksh clitest tests.txt        # Uses Korn
 ## Portability
 
 This script was carefully coded to be portable between [POSIX][13]
-shells.
+shells. It's code is validated by [checkbashisms][25] and
+[shellcheck][26].
 
-It was tested in:
+To make sure it keeps working as expected, after every change clitest is
+automatically tested in the CI, using the following shells:
 
-* Bash 3.2
-* dash 0.5.5.1
-* ksh 93u 2011-02-08
-* zsh 5.0.5
+- bash
+- dash
+- ksh
+- sh (busybox)
+- zsh
 
 Portability issues are considered serious bugs, please
 [report them][14]!
@@ -493,3 +515,5 @@ No other language or environment involve
 [22]: https://github.com/aureliojargas/clitest/blob/master/LICENSE.txt
 [23]: https://www.gnu.org/software/bash/manual/html_node/Bash-POSIX-Mode.html
 [24]: https://github.com/funcoeszz/funcoeszz/tree/master/testador
+[25]: https://linux.die.net/man/1/checkbashisms
+[26]: https://www.shellcheck.net/
diff -pruN 0.3.0-3/test/inline-match-file-error-2.sh 0.4.0-1/test/inline-match-file-error-2.sh
--- 0.3.0-3/test/inline-match-file-error-2.sh	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/test/inline-match-file-error-2.sh	2020-07-01 22:53:52.000000000 +0000
@@ -1 +1 @@
-$ echo "error: file not found"  #=> --file XXnotfoundXX
+$ echo "error: file not found"  #=> --file notfound
diff -pruN 0.3.0-3/test/stdout-stderr.sh 0.4.0-1/test/stdout-stderr.sh
--- 0.3.0-3/test/stdout-stderr.sh	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/test/stdout-stderr.sh	2020-07-01 22:53:52.000000000 +0000
@@ -26,20 +26,20 @@ $
 
 # Showing STDERR
 
-$ ./clitest foo
-clitest: Error: cannot read input file: foo
-$ ./clitest foo > /dev/null
-clitest: Error: cannot read input file: foo
+$ ./clitest notfound
+clitest: Error: cannot read input file: notfound
+$ ./clitest notfound > /dev/null
+clitest: Error: cannot read input file: notfound
 $
 
 # Redirecting STDERR to STDOUT
 
-$ ./clitest foo 2>&1
-clitest: Error: cannot read input file: foo
+$ ./clitest notfound 2>&1
+clitest: Error: cannot read input file: notfound
 $
 
 # Closing STDERR
 
-$ ./clitest foo 2> /dev/null
-$ ./clitest foo > /dev/null 2>&1
+$ ./clitest notfound 2> /dev/null
+$ ./clitest notfound > /dev/null 2>&1
 $
diff -pruN 0.3.0-3/test.md 0.4.0-1/test.md
--- 0.3.0-3/test.md	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/test.md	2020-07-01 22:53:52.000000000 +0000
@@ -22,6 +22,8 @@ $
 Set a default terminal width of 80 columns. It's used by separator lines.
 
 ```
+$ shopt -u checkwinsize 2> /dev/null  # bash: disable automatic check
+$ unset COLUMNS  # mksh: first unset, then one can manually set it
 $ COLUMNS=80
 $ export COLUMNS
 $
@@ -45,10 +47,10 @@ $ echo $not_exported  #=> --regex ^1$
 
 ```
 $ TMPDIR___SAVE="$TMPDIR"
-$ TMPDIR=/XXnotfoundXX
+$ TMPDIR=/notfound
 $ export TMPDIR
 $ ./clitest test/ok-1.sh 2>&1 | grep ^clitest | sed 's/clitest\..*$/clitest.XXXXXX/'
-clitest: Error: cannot create temporary dir: /XXnotfoundXX/clitest.XXXXXX
+clitest: Error: cannot create temporary dir: /notfound/clitest.XXXXXX
 $ TMPDIR="$TMPDIR___SAVE"
 $
 ```
@@ -71,15 +73,21 @@ $
 File not found
 
 ```
-$ ./clitest XXnotfoundXX.sh; echo $?
-clitest: Error: cannot read input file: XXnotfoundXX.sh
+$ ./clitest notfound; echo $?
+clitest: Error: cannot read input file: notfound
 2
+$
+```
+
+File is a directory
+
+```
 $ ./clitest .
-clitest: Error: cannot read input file: .
+clitest: Error: input file is a directory: .
 $ ./clitest ./
-clitest: Error: cannot read input file: ./
+clitest: Error: input file is a directory: ./
 $ ./clitest /etc
-clitest: Error: cannot read input file: /etc
+clitest: Error: input file is a directory: /etc
 $
 ```
 
@@ -112,11 +120,9 @@ Test the output text and the short optio
 
 ```
 $ ./clitest --version
-clitest HEAD
-https://github.com/aureliojargas/clitest/tree/HEAD
+clitest 0.4.0
 $ ./clitest -V
-clitest HEAD
-https://github.com/aureliojargas/clitest/tree/HEAD
+clitest 0.4.0
 $
 ```
 
@@ -146,6 +152,8 @@ Customization options:
       --inline-prefix PREFIX  Set inline output prefix (default: '#=> ')
       --prefix PREFIX         Set command line prefix (default: '')
       --prompt STRING         Set prompt string (default: '$ ')
+
+See also: https://github.com/aureliojargas/clitest
 0
 $
 ```
@@ -155,7 +163,7 @@ The short option `-h` is working? Testin
 ```
 $ ./clitest -h | sed -n '1p; $p'
 Usage: clitest [options] <file ...>
-      --prompt STRING         Set prompt string (default: '$ ')
+See also: https://github.com/aureliojargas/clitest
 $
 ```
 
@@ -181,8 +189,8 @@ $
 ## Option --quiet has no effect in error messages
 
 ```
-$ ./clitest --quiet /etc
-clitest: Error: cannot read input file: /etc
+$ ./clitest --quiet notfound
+clitest: Error: cannot read input file: notfound
 $
 ```
 
@@ -728,6 +736,17 @@ $ ./clitest --list-run -t 3,5-7 test/ok-
 $
 ```
 
+Reverse ranges and repeated numbers are supported
+
+```
+$ ./clitest --list -t 3,7-5,3,6,5 test/ok-10.sh
+#3	echo 3 
+#5	echo 5 
+#6	echo 6 
+#7	echo 7 
+$
+```
+
 Using `-t` to limit to a range and the `-s` exclude some more
 
 ```
@@ -1332,7 +1351,7 @@ clitest: Error: empty --file at line 1 o
 2
 $ ./clitest test/inline-match-file-error-2.sh; echo $?
 #1	echo "error: file not found"  
-clitest: Error: cannot read inline output file 'test/XXnotfoundXX', from line 1 of test/inline-match-file-error-2.sh
+clitest: Error: cannot read inline output file 'test/notfound', from line 1 of test/inline-match-file-error-2.sh
 2
 $ ./clitest test/inline-match-file-error-3.sh; echo $?
 #1	echo "error: directory"  
@@ -2074,6 +2093,10 @@ FAIL: 50 of 50 tests failed
 $ ./clitest --pre-flight 'false' test/ok-1.sh; echo $?
 clitest: Error: pre-flight command failed with status=1: false
 2
+$ ./clitest --post-flight 'false' test/ok-1.sh; echo $?
+#1	echo ok
+clitest: Error: post-flight command failed with status=1: false
+2
 $
 ```
 
@@ -2102,23 +2125,36 @@ clitest: Error: cannot read input file:
 $
 ```
 
-## File - meaning STDIN (not supported)
+## File - meaning STDIN
 
 ```
 $ cat test/ok-1.sh | ./clitest -
-clitest: Error: cannot read input file: -
+#1	echo ok
+OK: 1 of 1 test passed
 $ cat test/ok-1.sh | ./clitest -- -; echo $?
-clitest: Error: cannot read input file: -
-2
+#1	echo ok
+OK: 1 of 1 test passed
+0
 $
 ```
 
-## Read test file from STDIN (not supported)
+## Read test file from /dev/stdin
 
 ```
-$ cat test/ok-1.sh | ./clitest /dev/stdin; echo $?
-clitest: Error: cannot read input file: /dev/stdin
-2
+$ cat test/ok-1.sh | ./clitest /dev/stdin
+#1	echo ok
+OK: 1 of 1 test passed
+$
+```
+
+## Test file is a symlink
+
+```
+$ ln -s test/ok-1.sh testsymlink
+$ ./clitest testsymlink
+#1	echo ok
+OK: 1 of 1 test passed
+$ rm testsymlink
 $
 ```
 
@@ -2127,8 +2163,8 @@ $
 Test exit code and STDOUT/STDERR at the same time
 
 ```
-$ ./clitest foo; echo $?
-clitest: Error: cannot read input file: foo
+$ ./clitest notfound; echo $?
+clitest: Error: cannot read input file: notfound
 2
 $ ./clitest test/exit-code-and-stdout.sh 
 #1	echo "zero"; echo $?
@@ -2146,11 +2182,11 @@ $ ./clitest test/stdout-stderr.sh
 #3	echo "stderr" 1>&2
 #4	echo "stdout" > /dev/null
 #5	echo "stdout" 2> /dev/null 1>&2
-#6	./clitest foo
-#7	./clitest foo > /dev/null
-#8	./clitest foo 2>&1
-#9	./clitest foo 2> /dev/null
-#10	./clitest foo > /dev/null 2>&1
+#6	./clitest notfound
+#7	./clitest notfound > /dev/null
+#8	./clitest notfound 2>&1
+#9	./clitest notfound 2> /dev/null
+#10	./clitest notfound > /dev/null 2>&1
 OK: 10 of 10 tests passed
 $
 ```
diff -pruN 0.3.0-3/.travis.yml 0.4.0-1/.travis.yml
--- 0.3.0-3/.travis.yml	2016-03-15 23:26:34.000000000 +0000
+++ 0.4.0-1/.travis.yml	2020-07-01 22:53:52.000000000 +0000
@@ -1,33 +1,10 @@
 language: bash
 
-os:
-  - linux
-  - osx
-
-# Prepare the environment
-addons:
-  apt:
-    packages:
-      # Linux: only bash (and sh) are installed by default
-      - ksh
-      - zsh
-      # Linux: install the checkbashisms script
-      - devscripts
-before_install:
-  # OS X: install the checkbashisms script (||true to avoid Linux fail)
-  - test "$TRAVIS_OS_NAME" = osx && brew update                || true
-  - test "$TRAVIS_OS_NAME" = osx && brew install checkbashisms || true
-  - test "$TRAVIS_OS_NAME" = osx && brew install dash          || true
-
 script:
-  # Run some code checkings on the script itself
-  - checkbashisms --posix clitest
-  # Run the full test suite in all the supported POSIX shells
-  - bash clitest test.md
-  - dash clitest test.md
-  - ksh  clitest test.md
-  - zsh  clitest test.md
-  - sh   clitest test.md
+  - make docker-build
+  - make versions
+  - make lint
+  - make test
 
 notifications:
   email: false
